import React, { useEffect, useContext } from 'react'
import { Input, Popover, ConfigProvider } from 'antd'
import { QrcodeOutlined } from '@ant-design/icons'
import QRcode from 'qrcode.react'
import styles from './index.less'

const Coding = (props) => {

  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('pandaXform')
  const { value, onChange, addons, schema } = props
  const { disabled, prefixion, codingType, presetValue, required, placeholder } = schema
  console.log(props, 'propspropspropspropsprops');
  const inputChange = (e) => {
    onChange(e.target.value)
  }

  useEffect(() => {
    if (addons) {
      addons.setValue(addons.dataPath, presetValue || '')
    } else {
      onChange(presetValue || '')
    }
  }, [])
  
  useEffect(()=>{
    if(!value && !presetValue){
      const val =  generateCode(Number(codingType))
      onChange(val)
    }
  }, [])

  const generateCode = (type) => {
    const prefix = prefixion || '';
    const year = new Date().getFullYear().toString();
    const month = (new Date().getMonth() + 1).toString().padStart(2, '0');
    const randomSixDigits = Math.floor(100000 + Math.random() * 900000).toString();
    const randomEightDigits = Math.floor(10000000 + Math.random() * 90000000).toString();

    switch (type) {
      case 1:
        return `${prefix}-${year}-${randomSixDigits}`;
      case 2:
        return `${prefix}-${year}${month}-${randomSixDigits}`;
      case 3:
        return `${prefix}-${randomEightDigits}`;
      default:
        return '';
    }
  };
  const content = (
    <div>
      <QRcode value={value} />
    </div>
  )

  return (
    <div className={styles.coding} isdisabled={JSON.stringify(disabled)}>
      <Input
        placeholder={disabled ? (placeholder || '') : (placeholder || '请输入内容')}
        onChange={inputChange}
        value={value}
        disabled={disabled}
        addonAfter={
          <Popover content={value ? content : null}>
            <QrcodeOutlined />
          </Popover>
        }
      />
    </div>
  )

}

export default Coding